var model = avalon.define({
	$id: 'edit',
	data: {
		'id': "",
		'systemId': "",
		'parentId': "",
		'authorName': "",
		'authorCode': "",
		'urlAddress': "",
		'isMenu': "0",
		'menuIcon': "",
		'sortNumber': "",

		'menuType': "0",
		'vueMenuPath': "",
		'vueMenuComponent': "",
		'vueMenuRedirect': "",
		'vueMenuHidden': false,
		'vueMenuName': "",
		
		'isEnable': "1",
		'remark': ""
	},
	flag: false,
	parentName: "",
	showTree: function() {
		model.flag = true;
		$("#dep-tree").show();
	},
	hideTree: function() {
		model.flag = false;
	},
	systemList:[]
});
var zTree; //zTree对象
var THISPAGE = {
	_init: function() {
		var self = this;
		self.api = frameElement.api;
		// 接收id
		self.id = self.api.data.id;
		self._render();
		self._bindEvent();
		self._getSyetemList();
		//初始化树
		self._inintTree();
	},

	_render: function() {
		var self = this;
		self._validator();
		self._getInfo();
	},
	_bindEvent: function() {
		var self = this;
		// 初始化按钮 及 绑定事件
		self.api.button({
			id: "saveAndNew",
			focus: !0,
			name: "<i class='fa fa-save mrb'></i> 保存",
			callback: function() {
				$("#base_form").trigger("validate");
				return false
			}
		}, {
			name: "关闭"
		});
	},
	_getSyetemList: function() {
		var self = this;
		Public.ajaxGet("/system/getList",null, function(res) {
			if (res.successed) {
				model.systemList=res.returnValue;
				console.log(res.returnValue);
			} else {
				parent.parent.Public.tips({
					type: 1,
					content: "新增失败！" + res.errorDesc
				});
			}
		});
	},
	_inintTree: function() {

		var url = "/author/getAuthorTreeList";
		//zTree基本设置  
		var setting = {
			treeId: "tree",
			treeObj: null,
			edit: {
				enable: true,
				showRenameBtn: false,
				showRemoveBtn: false,
			},
			data: {
				keep: {
					leaf: false,
					parent: false
				},
				key: {
					children: "child",
					name: "authorName",
					title: "authorName"
				},
				simpleData: {
					enable: false,
					idKey: "id",
					pIdKey: "parentId",
					rootPId: null
				}
			},
			callback: {
				onClick: zTreeOnClick
			}


		};

		function zTreeOnClick(event, treeId, treeNode) {
			var nodeName = treeNode.authorName; //删除的节点名称
			var nodeId = treeNode.id; //删除的节点id
			model.parentName = nodeName;
			model.data.parentId = nodeId;
			model.flag = false; //隐藏父级权限树
		};
		//初始化数据
		function inintTree() {
			$.ajax({
				async: false,
				cache: false,
				type: 'GET',
				dataType: "json",
				url: url,
				//请求的action路径  
				error: function() { //请求失败处理函数  
					parent.Public.tips({
						type: 1,
						content: res.errorDesc
					})
				},
				success: function(res) { //请求成功后处理函数。    
					if (res.successed) {
						//初始化数据
						zTree = $.fn.zTree.init($("#tree"), setting, res.returnValue);
						zTree.expandAll(true);
					} else {
						parent.Public.tips({
							type: 1,
							content: res.errorDesc
						})
					}
				}
			});
		};
		inintTree();
	},
	//查询详情
	_getInfo: function() {
		var self = this;
		Public.ajaxGet("/author/getDetail", {
			id: self.id
		}, function(res) {
			if (res.successed) {
				avalon.mix(model.data, res.returnValue);
				model.data.systemId= res.returnValue.systemId;
				//选中默认父级节点
				if (model.data.parentId && model.data.parentId != "null") {
					var node = zTree.getNodeByParam("id", model.data.parentId, null);
					model.parentName = node.authorName;
					zTree.selectNode(node, false);
				} else {
					model.data.parentId = "";
				}
			} else {
				parent.Public.tips({
					type: 1,
					content: res.errorDesc
				});
			}
		});

	},
	_updateData: function() {
		var self = this;
		model.data.menuIcon = $("#preview").attr("src");
		Public.ajaxPost("/author/update", model.data.$model, function(res) {
			if (res.successed) {
				// 成功提示框
				parent.parent.Public.tips({
					content: "修改成功！"
				});

				// 调用index中_reloadData 重新加载数据
				parent.THISPAGE._reloadData();
				// 关闭模态框
				self.api.close();

			} else {
				parent.parent.Public.tips({
					type: 1,
					content: "修改失败！" + res.errorDesc
				});
			}
		});
	},
	_validator: function() {
		var self = this;
		$("#base_form").validator({

			valid: function() {
				self._updateData();
			},
			ignore: ":hidden",
			theme: "yellow_bottom",
			timely: 1,
			stopOnError: true
		});
	}
};

THISPAGE._init();