var model = avalon.define({
	$id: 'add',
	data: {
		'parentId': "",
		'departmentName': "",
		'departmentCode': "",
		'sortNumber': "",
		'isEnable': 0,
		'remark': ""
	},
	flag: false,
	parentName: "",
	showTree: function() {
		model.flag = true;
	},
	hideTree: function() {
		model.flag = false;
	}
});


var THISPAGE = {

	_init: function() {
		var self = this;
		self.api = frameElement.api;
		// 接收id
		model.data.parentId = self.api.data.parentId;
		self._render();
		self._bindEvent();
		self._inintTree();
	},
	_render: function() {
		var self = this;
		self._validator();
	},
	_bindEvent: function() {
		var self = this;
		// 初始化按钮 及 绑定事件
		self.api.button({
			id: "saveAndNew",
			focus: !0,
			name: "<i class='fa fa-save mrb'></i> 保存",
			callback: function() {
				$("#base_form").trigger("validate");
				return false;
			}
		}, {
			name: "关闭"
		});
	},
	_inintTree: function() {
		var self = this;
		var zTree; //zTree对象
		var url = "/department/getDepartmentTreeList";
		//zTree基本设置  
		var setting = {
			treeId: "tree",
			treeObj: null,
			edit: {
				enable: true,
				showRenameBtn: false,
				showRemoveBtn: false,
			},
			data: {
				keep: {
					leaf: false,
					parent: false
				},
				key: {
					children: "child",
					name: "departmentName",
					title: "departmentName"
				},
				simpleData: {
					enable: false,
					idKey: "id",
					pIdKey: "parentId",
					rootPId: null
				}
			},
			callback: {
				onClick: zTreeOnClick
			}


		};

		function zTreeOnClick(event, treeId, treeNode) {
			var nodeName = treeNode.departmentName; //删除的节点名称
			var nodeId = treeNode.id; //删除的节点id
			model.parentName = nodeName;
			model.data.parentId = nodeId;
			model.flag = false; //隐藏父级部门树
		};
		//初始化数据
		function inintTree() {
			$.ajax({
				async: false,
				cache: false,
				type: 'GET',
				dataType: "json",
				url: url,
				//请求的action路径  
				error: function() { //请求失败处理函数  
					parent.Public.tips({
						type: 1,
						content: res.errorDesc
					})
				},
				success: function(res) { //请求成功后处理函数。    
					if (res.successed) {
						//初始化数据
						zTree = $.fn.zTree.init($("#tree"), setting, res.returnValue);
						zTree.expandAll(true);
						//选中默认父级节点
						var node = zTree.getNodeByParam("id", model.data.parentId, null);
						if (node) {
							model.parentName = node.departmentName;
							zTree.selectNode(node, false);
						}
					} else {
						parent.Public.tips({
							type: 1,
							content: res.errorDesc
						})
					}
				}

			});
		};
		inintTree();
	},
	_addData: function() {
		var self = this;
		Public.ajaxPost("/department/add", model.data.$model, function(res) {
			if (res.successed) {
				// 成功提示框
				parent.parent.Public.tips({
					content: "新增成功！"
				});
				// 调用index中_reloadData 重新加载数据
				parent.THISPAGE._loadGrid();
				// 关闭模态框
				self.api.close();

			} else {
				parent.parent.Public.tips({
					type: 1,
					content: "新增失败！" + res.errorDesc
				});
			}
		});
	},
	_validator: function() {
		var self = this;
		$("#base_form").validator({

			valid: function() {
				self._addData();
			},
			ignore: ":hidden",
			theme: "yellow_bottom",
			timely: 1,
			stopOnError: true
		});
	}
};


THISPAGE._init();