var model = avalon.define({
	$id: 'index',
	query: {
		keywords: "",
		startTime: '',
		endTime: ''
	},
	// 重置查询条件
	_clear: function() {
		model.query = {
			keywords: "",
			startTime: '',
			endTime: ''
		};
	}
});

var THISPAGE = {
	_init: function() {
		var self = this;
		self.id = "";
		self.ids = "";

		self._render();
		self._bindEvent();
	},
	_render: function() {
		var self = this;
		self._loadGrid();
		$(".ui-datepicker-input").datepicker();
	},
	_bindEvent: function() {
		var self = this;
		$(window).resize(function() {
			Public.resizeGrid()
		});
		// 搜索
		$("#J_search").click(function() {
			self._reloadData()
		});
		// 刷新
		$("#J_refresh").click(function() {
			model._clear();
			self._reloadData();
		});
		// 选中开始日期
		$("#startTime").change(function() {
			model.query.startTime = $("#startTime").val();
		})
		// 选中结束日期
		$("#endTime").change(function() {
			model.query.endTime = $("#endTime").val();
		})
		// 查看
		$(".grid-wrap").on("click", ".opt-view", function(t) {
			t.preventDefault();
			self.id = $(this).parent().data("id");
			self._giveDialogView();
		});

	},
	_giveDialogView: function() {
		var self = this;
		$.dialog({
			init: function() {
				var height = $(window).height() - 65;
				$(".ui_main").css("height", height);
			},

			id: "moreCon",
			min: true,
			max: true,
			title: "查看登录日志",
			resize: true,
			lock: true,
			content: "url:" + "/loginlog/view.html",
			data: {
				id: self.id
			}
		}).max();
	},
	_loadGrid: function() {
		var self = this;
		// 操作按钮
		function opBtnHtml(val, opt, row) {
			var html_con = '<div class="operating" data-id="' + row.id + '"></span><span class="fa fa-eye mrb opt-view" title="查看"></span></div>';
			return html_con;
		};
		// 初始化表格高/宽
		var i = Public.setGrid();
		$("#grid").jqGrid({
			url: "/loginlog/getPageList",
			postData: model.query.$model,
			datatype: "json",
			mtype: 'GET',
			autowidth: true,
			height: i.h,
			altRows: true,
			gridview: true,
			rownumbers: true,
			multiselect: true,
			multiboxonly: false,
			colModel: [{
				name: "operating",
				label: "操作",
				fixed: true,
				width: 120,
				formatter: opBtnHtml,
				align: "center",
				sortable: false,
				title: false
			}, {
				name: "loginUserId",
				label: "登录用户",
				align: "center",
				width: 150,
				sortable: true,
				title: true
			}, {
				name: "remark",
				label: "登录用户名",
				align: "center",
				width: 150,
				sortable: true,
				title: true
			}, {
				name: "lastLoginIp",
				label: "上次登录ip",
				align: "center",
				width: 200,
				sortable: true,
				title: true
			}, {
				name: "lastLoginTime",
				label: "登录时间",
				align: "center",
				width: 200,
				sortable: true,
				title: true
			}, {
				name: "isLoginSuccess",
				label: "是否成功",
				formatter: function(v, e, r) { if (v == 1) return "是";
					else return "否"; },
				align: "center",
				width: 200,
				sortable: true,
				title: true
			}],
			page: 1,
			sortname: "created",
			sortorder: "desc",
			pager: "#page",
			rowNum: 50,
			rowList: [50, 100],
			viewrecords: true,
			shrinkToFit: false,
			forceFit: false,
			jsonReader: {
				root: "returnValue.list",
				records: "returnValue.total",
				total: "returnValue.pages",
				repeatitems: false,
				id: "id"
			},
			loadError: function() {
				parent.Public.tips({
					type: 1,
					content: "加载数据异常！"
				})
			},
			gridComplete: function() {
				var ids = $('#grid').jqGrid('getDataIDs');
				for (var i = 0; i < ids.length; i++) {
					var id = ids[i];
					$("#" + id).attr("style", "cursor:pointer");
				}
			}
		});

	},

	_reloadData: function() {
		var self = this;
		$("#grid").jqGrid("setGridParam", {
			url: "/loginlog/getPageList",
			datatype: "json",
			mtype: 'GET',
			postData: model.query.$model
		}).trigger("reloadGrid");
	}
};

THISPAGE._init();