var model = avalon.define({
	$id: 'add',
	data: {
		'parentId': "",
		'departmentId': "",
		'roleCode': "",
		'roleName': "",
		'sortNumber': "",
		'remark': "",
		'isEnable': 0,
		'authors': "",
	},
	flag: false,
	isShowDepartmentTree: false,
	parentName: "",
	departmentName: "",
	authorFlag: false,
	authorNames: "",
	showTree: function() {
		model.flag = true;
	},
	hideTree: function() {
		model.flag = false;
	},
	showDepartmentTree: function() {
		model.isShowDepartmentTree = true;
	},
	hideDepartmentTree: function() {
		model.isShowDepartmentTree = false;
	},
	showAuthorTree: function() {
		model.authorFlag = true;
	}
});


var THISPAGE = {

	_init: function() {
		var self = this;
		self.api = frameElement.api;
		// 接收id
		model.data.parentId = self.api.data.parentId;
		model.data.departmentId = self.api.data.departmentId;
		self._render();
		self._bindEvent();
		self._inintTree();
		self._inintDepartmentTree();
		// 初始化权限树
		self._loadGrid();
	},
	_render: function() {
		var self = this;
		self._validator();
	},
	_bindEvent: function() {
		var self = this;
		// 初始化按钮 及 绑定事件
		self.api.button({
			id: "saveAndNew",
			focus: !0,
			name: "<i class='fa fa-save mrb'></i> 保存",
			callback: function() {
				$("#base_form").trigger("validate");
				return false;
			}
		}, {
			name: "关闭"
		});
	},
	_inintTree: function() {
		var self = this;
		var zTree; //zTree对象
		var url = "/role/getRoleTreeList";
		//zTree基本设置
		var setting = {
			treeId: "tree",
			treeObj: null,
			edit: {
				enable: true,
				showRenameBtn: false,
				showRemoveBtn: false,
			},
			data: {
				keep: {
					leaf: false,
					parent: false
				},
				key: {
					children: "child",
					name: "roleName",
					title: "roleName"
				},
				simpleData: {
					enable: false,
					idKey: "id",
					pIdKey: "parentId",
					rootPId: null
				}
			},
			callback: {
				onClick: zTreeOnClick
			}


		};

		function zTreeOnClick(event, treeId, treeNode) {
			var nodeName = treeNode.roleName; //删除的节点名称
			var nodeId = treeNode.id; //删除的节点id
			model.parentName = nodeName;
			model.data.parentId = nodeId;
			model.flag = false; //隐藏父级部门树
		};

		// 当点击非tree所在区域时隐藏tree
		function zTreeExcludeOnClick() {
			$("#roleTreeDiv").click(function(event) {
				event = event || window.event;
				model.flag = true;
				event.stopPropagation();
			})
			$(document).click(function(event) {
				model.flag = false;
			})
		};

		//初始化数据
		function inintTree() {
			$.ajax({
				async: false,
				cache: false,
				type: 'GET',
				dataType: "json",
				url: url,
				//请求的action路径
				error: function() { //请求失败处理函数
					parent.Public.tips({
						type: 1,
						content: res.errorDesc
					})
				},
				success: function(res) { //请求成功后处理函数。
					if (res.successed) {
						//初始化数据
						zTree = $.fn.zTree.init($("#tree"), setting, res.returnValue);
						zTree.expandAll(true);
						//选中默认父级节点
						var node = zTree.getNodeByParam("id", model.data.parentId, null);
						if (node) {
							model.parentName = node.roleName;
						}
					} else {
						parent.Public.tips({
							type: 1,
							content: res.errorDesc
						})
					}
				}

			});
		};
		inintTree();
	},

	_inintDepartmentTree: function() {
		var self = this;
		var departmentTree; //zTree对象
		var url = "/department/getDepartmentTreeList";
		//zTree基本设置
		var setting = {
			treeId: "departmentTree",
			treeObj: null,
			edit: {
				enable: true,
				showRenameBtn: false,
				showRemoveBtn: false,
			},
			data: {
				keep: {
					leaf: false,
					parent: false
				},
				key: {
					children: "child",
					name: "departmentName",
					title: "departmentName"
				},
				simpleData: {
					enable: false,
					idKey: "id",
					pIdKey: "parentId",
					rootPId: null
				}
			},
			callback: {
				onClick: zTreeOnClick
			}


		};

		function zTreeOnClick(event, treeId, treeNode) {
			var nodeName = treeNode.departmentName; //选中的节点名称
			var nodeId = treeNode.id; //选中的节点id
			model.departmentName = nodeName;
			model.data.departmentId = nodeId;
			model.flag = isShowDepartmentTree; //隐藏父级部门树
		};
		//初始化数据
		function inintTree() {
			$.ajax({
				async: false,
				cache: false,
				type: 'GET',
				dataType: "json",
				url: url,
				//请求的action路径
				error: function() { //请求失败处理函数
					parent.Public.tips({
						type: 1,
						content: res.errorDesc
					})
				},
				success: function(res) { //请求成功后处理函数。
					if (res.successed) {
						//初始化数据
						departmentTree = $.fn.zTree.init($("#departmentTree"), setting, res.returnValue);
						departmentTree.expandAll(true);
						//选中默认父级节点
						var node = departmentTree.getNodeByParam("id", model.data.departmentId, null);
						if (node) {
							model.departmentName = node.departmentName;
							departmentTree.selectNode(node, false);
						}
					} else {
						parent.Public.tips({
							type: 1,
							content: res.errorDesc
						})
					}
				}

			});
		};
		inintTree();
	},
	_addData: function() {
		var self = this;
		Public.ajaxPost("/role/add", model.data.$model, function(res) {
			if (res.successed) {
				// 成功提示框
				parent.parent.Public.tips({
					content: "新增成功！"
				});
				// 调用index中_reloadData 重新加载数据
				parent.THISPAGE._loadGrid();
				// 关闭模态框
				self.api.close();

			} else {
				parent.parent.Public.tips({
					type: 1,
					content: "新增失败！" + res.errorDesc
				});
			}
		});
	},
	_validator: function() {
		var self = this;
		$("#base_form").validator({

			valid: function() {
				self._addData();
			},
			ignore: ":hidden",
			theme: "yellow_bottom",
			timely: 1,
			stopOnError: true
		});
	},
	//加载权限树数据
	_loadGrid: function() {
		var self = this;
		var zTree; //zTree对象
		var url = "/author/getAuthorTreeList";
		//zTree基本设置
		var setting = {
			treeId: "authorTree",
			treeObj: null,
			edit: {
				enable: true,
				showRemoveBtn: false,
				showRenameBtn: false,
			},
			async: {
				autoParam: ["id=id"],
				//节点ID作为参数id上传
				type: "get"
			},
			check: {
				//是否启用checkBox
				enable: true,
				//true / false 分别表示 触发 / 不触发 事件回调函数
				autoCheckTrigger: false,
				//框框类型
				chkStyle: "checkbox",
				//checkbox 勾选操作，只影响父级节点；取消勾选操作，只影响子级节点
				chkboxType: {
					"Y": "s",
					"N": "s"
				}
			},
			data: {
				keep: {
					leaf: false,
					parent: false
				},
				key: {
					children: "child",
					name: "authorName",
					title: "authorName"
				},
				simpleData: {
					enable: false,
					idKey: "id",
					pIdKey: "parentId",
					rootPId: null
				}
			}

		};
		// 当点击非tree所在区域时隐藏tree
		function zTreeExcludeOnClick() {
			$("#authorTreeDiv").click(function(event) {
				event = event || window.event;
				getAuthorNames();
				model.authorFlag = true;
				event.stopPropagation();
			})
			$(document).click(function(event) {
				getAuthorNames();
				model.authorFlag = false;
			})
		};

		// 获取权限名称
		function getAuthorNames() {
			var zTree = $.fn.zTree.getZTreeObj("authorTree");
			var nodes = zTree.getCheckedNodes(true); //获取选中的节点
			var authors = [],
				authorNames = "";
			var nodeLength = nodes.length;
			//拼装要删除的id，以逗号隔开的字符串
			for (var i = 0; i < nodeLength; i++) {
				let author = {
					authorId: nodes[i].id,
					systemId: nodes[i].systemId
				};
				authors.push(author);
				authorNames += nodes[i].authorName;
				if (i + 1 != nodeLength) {
					// authorIds += ",";
					authorNames += ",";
				}
			};
			model.data.authors = JSON.stringify(authors);
			model.authorNames = authorNames;
			console.log(model.data.authors)
		}

		//初始化权限树数据
		function inintTree() {
			$.ajax({
				data: {
					keywords: ""
				},
				async: false,
				cache: false,
				type: 'GET',
				dataType: "json",
				url: url,
				//请求的action路径
				error: function(res) { //请求失败处理函数
					parent.Public.tips({
						type: 1,
						content: res.errorDesc
					})
				},
				success: function(res) { //请求成功后处理函数。
					if (res.successed) {
						//初始化数据
						zTree = $.fn.zTree.init($("#authorTree"), setting, res.returnValue);
						zTree.expandAll(true);
					} else {
						parent.Public.tips({
							type: 1,
							content: res.errorDesc
						})
					}
				}

			});
		};

		//初始化
		inintTree();
		// 点击div其他区域时隐藏div
		zTreeExcludeOnClick();
	},
};


THISPAGE._init();