var model = avalon.define({
	$id: 'edit',
	data: {
		'id': "",
		'parentId': "",
		'departmentId': "",
		'roleCode': "",
		'roleName': "",
		'sortNumber': "",
		'remark': "",
		'isEnable': 0
	},
	flag: false,
	isShowDepartmentTree: false,
	parentName: "",
	departmentName: "",
	showTree: function() {
		model.flag = true;
	},
	hideTree: function() {
		model.flag = false;
	},
	showDepartmentTree: function() {
		model.isShowDepartmentTree = true;
	},
	hideDepartmentTree: function() {
		model.isShowDepartmentTree = false;
	}
});
var zTree; //zTree对象
var departmentTree; //zTree对象
var THISPAGE = {
	_init: function() {
		var self = this;
		self.api = frameElement.api;
		// 接收id
		self.id = self.api.data.id;
		self._render();
		self._bindEvent();
		//初始化树
		self._inintTree();
		self._inintDepartmentTree();
	},

	_render: function() {
		var self = this;
		self._validator();
		self._getInfo();
	},
	_bindEvent: function() {
		var self = this;
		// 初始化按钮 及 绑定事件
		self.api.button({
			id: "saveAndNew",
			focus: !0,
			name: "<i class='fa fa-save mrb'></i> 保存",
			callback: function() {
				$("#base_form").trigger("validate");
				return false
			}
		}, {
			name: "关闭"
		});
	},
	_inintTree: function() {

		var url = "/role/getRoleTreeList";
		//zTree基本设置  
		var setting = {
			treeId: "tree",
			treeObj: null,
			edit: {
				enable: true,
				showRenameBtn: false,
				showRemoveBtn: false,
			},
			data: {
				keep: {
					leaf: false,
					parent: false
				},
				key: {
					children: "child",
					name: "roleName",
					title: "roleName"
				},
				simpleData: {
					enable: false,
					idKey: "id",
					pIdKey: "parentId",
					rootPId: null
				}
			},
			callback: {
				onClick: zTreeOnClick
			}


		};

		function zTreeOnClick(event, treeId, treeNode) {
			var nodeName = treeNode.roleName; //删除的节点名称
			var nodeId = treeNode.id; //删除的节点id
			model.parentName = nodeName;
			model.data.parentId = nodeId;
			model.flag = true; //隐藏父级部门树
		};
		//初始化数据
		function inintTree() {
			$.ajax({
				async: false,
				cache: false,
				type: 'GET',
				dataType: "json",
				url: url,
				//请求的action路径  
				error: function() { //请求失败处理函数  
					parent.Public.tips({
						type: 1,
						content: res.errorDesc
					})
				},
				success: function(res) { //请求成功后处理函数。    
					if (res.successed) {
						//初始化数据
						zTree = $.fn.zTree.init($("#tree"), setting, res.returnValue);
						zTree.expandAll(true);
					} else {
						parent.Public.tips({
							type: 1,
							content: res.errorDesc
						})
					}
				}
			});
		};
		inintTree();
	},
	_inintDepartmentTree: function() {
		var self = this;
		var url = "/department/getDepartmentTreeList";
		//zTree基本设置  
		var setting = {
			treeId: "departmentTree",
			treeObj: null,
			edit: {
				enable: true,
				showRenameBtn: false,
				showRemoveBtn: false,
			},
			data: {
				keep: {
					leaf: false,
					parent: false
				},
				key: {
					children: "child",
					name: "departmentName",
					title: "departmentName"
				},
				simpleData: {
					enable: false,
					idKey: "id",
					pIdKey: "parentId",
					rootPId: null
				}
			},
			callback: {
				onClick: zTreeOnClick
			}


		};

		function zTreeOnClick(event, treeId, treeNode) {
			var nodeName = treeNode.departmentName; //选中的节点名称
			var nodeId = treeNode.id; //选中的节点id
			model.departmentName = nodeName;
			model.data.departmentId = nodeId;
			model.isShowDepartmentTree = false; //隐藏父级部门树
		};
		//初始化数据
		function inintTree() {
			$.ajax({
				async: false,
				cache: false,
				type: 'GET',
				dataType: "json",
				url: url,
				//请求的action路径  
				error: function() { //请求失败处理函数  
					parent.Public.tips({
						type: 1,
						content: res.errorDesc
					})
				},
				success: function(res) { //请求成功后处理函数。    
					if (res.successed) {
						//初始化数据
						departmentTree = $.fn.zTree.init($("#departmentTree"), setting, res.returnValue);
						departmentTree.expandAll(true);
						//选中默认父级节点
						var node = departmentTree.getNodeByParam("id", model.departmentId, null);
						if (node) {
							model.departmentName = node.departmentName;
						}
					} else {
						parent.Public.tips({
							type: 1,
							content: res.errorDesc
						})
					}
				}

			});
		};
		inintTree();
	},
	//查询详情
	_getInfo: function() {
		var self = this;
		Public.ajaxGet("/role/getDetail", {
			id: self.id
		}, function(res) {
			if (res.successed) {
				avalon.mix(model.data, res.returnValue);
				//选中默认父级节点
				if (model.data.parentId && model.data.parentId != "null") {
					var node = zTree.getNodeByParam("id", model.data.parentId, null);
					model.parentName = node.roleName;
				} else {
					model.data.parentId = "";
				}
				//默认选中部门
				if (model.data.departmentId && model.data.departmentId != "null") {
					var node = departmentTree.getNodeByParam("id", model.data.departmentId, null);
					model.departmentName = node.departmentName;
					departmentTree.selectNode(node, false);
				} else {
					model.data.departmentId = "";
				}

			} else {
				parent.Public.tips({
					type: 1,
					content: res.errorDesc
				});
			}
		});

	},
	_updateData: function() {
		var self = this;
		Public.ajaxPost("/role/update", model.data.$model, function(res) {
			if (res.successed) {
				// 成功提示框
				parent.parent.Public.tips({
					content: "修改成功！"
				});

				// 调用index中_reloadData 重新加载数据
				parent.THISPAGE._reloadData();
				// 关闭模态框
				self.api.close();

			} else {
				parent.parent.Public.tips({
					type: 1,
					content: "修改失败！" + res.errorDesc
				});
			}
		});
	},
	_validator: function() {
		var self = this;
		$("#base_form").validator({

			valid: function() {
				self._updateData();
			},
			ignore: ":hidden",
			theme: "yellow_bottom",
			timely: 1,
			stopOnError: true
		});
	}
};

THISPAGE._init();