var model = avalon.define({
	$id: 'index',
	query: {
		keywords: "",
		roleId: ""
	},
	expoutUrl: "",
	// 重置查询条件
	_clear: function() {
		model.query.keywords = ""
	}
});

var THISPAGE = {
	_init: function() {
		var self = this;
		self.api = frameElement.api;
		self.authorIds = "";
		self.roleId = self.api.data.roleId;
		
		model.query.roleId = self.roleId;
		self._render();
		self._bindEvent();
	},
	_render: function() {
		var self = this;
		self._loadGrid();
	},
	_bindEvent: function() {
		var self = this;
		// 搜索
		$("#J_search").click(function() {
			self._reloadData()
		});
		// 刷新
		$("#J_refresh").click(function() {
			model._clear();
			self._reloadData();
		});

		// 给角色分配权限
		$("#J_save").click(function(e) {
			e.preventDefault();
			var zTree = $.fn.zTree.getZTreeObj("tree");
			var nodes = zTree.getCheckedNodes(true); //获取选中的节点
			var selectNodeIds = "";
			var nodeLength = nodes.length;
			//拼装要删除的id，以逗号隔开的字符串
			for (var i = 0; i < nodeLength; i++) {
				selectNodeIds += nodes[i].id+"-"+nodes[i].systemId;
				if (i + 1 != nodeLength) {
					selectNodeIds += ",";
				}
			};
			self.authorAndSystemIds = selectNodeIds;
			self._distributionRoleAuthor();

		});
	},

	//加载权限树数据
	_loadGrid: function() {
		var self = this;
		var zTree; //zTree对象
		var url = "/author/getAuthorTreeListByRole";
		//zTree基本设置  
		var setting = {
			treeId: "tree",
			treeObj: null,
			view: {
				showTitle: true,
				expandFlag: true
			},
			edit: {
				enable: true,
				showRemoveBtn: false,
				showRenameBtn: false,
			},
			async: {
				autoParam: ["id=id"],
				//节点ID作为参数id上传
				type: "get"
			},
			check: {
//				enable: true,
//				//是否启用checkBox
//				autoCheckTrigger: false,
//				//true / false 分别表示 触发 / 不触发 事件回调函数
//				chkStyle: "checkbox",
//				//框框类型
				
				//是否启用checkBox
				enable: true,
				//true / false 分别表示 触发 / 不触发 事件回调函数
				autoCheckTrigger: false,
				//框框类型
				chkStyle: "checkbox",
				//checkbox 勾选操作，只影响父级节点；取消勾选操作，只影响子级节点
				chkboxType: {
					"Y": "s",
					"N": "s"
				}
			},
			data: {
				keep: {
					leaf: false,
					parent: false
				},
				key: {
					checked: "selected",//是否选中
					children: "child",
					name: "authorName",
					title: "authorName"
				},
				simpleData: {
					enable: false,
					idKey: "id",
					pIdKey: "parentId",
					rootPId: null
				}
			}

		};

		//初始化权限树数据
		function inintTree() {
			$.ajax({
				data: model.query.$model,
				async: false,
				cache: false,
				type: 'GET',
				dataType: "json",
				url: url,
				//请求的action路径  
				error: function() { //请求失败处理函数  
					parent.Public.tips({
						type: 1,
						content: res.errorDesc
					})
				},
				success: function(res) { //请求成功后处理函数。    
					if (res.successed) {
						//初始化数据
						zTree = $.fn.zTree.init($("#tree"), setting, res.returnValue);
						zTree.expandAll(true);
					} else {
						parent.Public.tips({
							type: 1,
							content: res.errorDesc
						})
					}
				}

			});
		};

		//初始化
		inintTree();
	},

	//给角色分配权限
	_distributionRoleAuthor: function() {
		var self = this;
		$.dialog.confirm("您确定要将选中的权限赋给角色吗？", function() {
			Public.ajaxPost("/role/distributionRoleAuthor", {
				authorAndSystemIds: self.authorAndSystemIds,
				roleId: self.roleId
			}, function(res) {
				if (res.successed) {
					// 调用index中_reloadData 重新加载数据
					parent.THISPAGE._reloadData();
					parent.Public.tips({
						content: "权限修改成功！"
					});
					// 关闭模态框
					self.api.close();
					

				} else {
					parent.Public.tips({
						type: 1,
						content: res.errorDesc
					})
				}

			})
		})
	},
	//刷新
	_reloadData: function() {
		var self = this;
		self._loadGrid();
	}
};

THISPAGE._init();