var model = avalon.define({
	$id: 'viewUser',
	query: {
		roleId: "",
	},
	// 重置查询条件
	_clear: function() {
		model.query = {
			roleId: "",
		};
	}
});

var THISPAGE = {
	_init: function() {
		var self = this;
		self.api = frameElement.api;
		model.query.roleId = self.api.data.roleId;
		self._render();
		self._bindEvent();
	},
	_render: function() {
		var self = this;
		self._loadGrid();
	},
	_bindEvent: function() {
		var self = this;
		$(window).resize(function() {
			Public.resizeGrid()
		});
	},
	_loadGrid: function() {
		var self = this;
		// 操作按钮
		// 初始化表格高/宽
		var i = Public.setGrid();
		$("#grid").jqGrid({
			url: "/user/getUserByRole",
			postData: model.query.$model,
			datatype: "json",
			mtype: 'GET',
			autowidth: true,
			height: i.h,
			altRows: true,
			gridview: true,
			rownumbers: true,
			multiselect: false,
			multiboxonly: false,
			colModel: [{
				name: "mobile",
				label: "手机号",
				align: "center",
				width: 120,
				sortable: false,
				title: true
			}, {
				name: "username",
				label: "用户名",
				align: "center",
				width: 120,
				sortable: false,
				title: true
			}, {
				name: "name",
				label: "姓名",
				align: "center",
				width: 120,
				sortable: false,
				title: true
			}, {
				name: "isEnable",
				label: "是否启用",
				align: "center",
				width: 120,
				formatter: function(v, e, r) {
					if (v == 1) return "是";
					else return "否";
				},
				sortable: false,
				title: true
			}, {
				name: "created",
				label: "创建日期",
				align: "center",
				width: 180,
				sortable: false,
				title: true
			}, {
				name: "updated",
				label: "修改日期",
				align: "center",
				width: 180,
				sortable: false,
				title: true
			}],
			page: 1,
			sortname: "created",
			sortorder: "desc",
			pager: "#page",
			rowNum: 9999,
			rowList: [50, 100],
			viewrecords: true,
			shrinkToFit: false,
			forceFit: false,
			jsonReader: {
				root: "returnValue",
				records: "returnValue.total",
				total: "returnValue.pages",
				repeatitems: false,
				id: "id"
			},
			loadError: function() {
				parent.Public.tips({
					type: 1,
					content: "加载数据异常！"
				})
			},
			gridComplete: function() {
				var ids = $('#grid').jqGrid('getDataIDs');
				for (var i = 0; i < ids.length; i++) {
					var id = ids[i];
					$("#" + id).attr("style", "cursor:pointer");
				}
			}
		});

	},
};

THISPAGE._init();